using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace TX_Text_Control_Words
{
	public class frmMDIParent : System.Windows.Forms.Form
	{
		#region Windows Form Designer generated code

		private System.Windows.Forms.MainMenu MainMenu1;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuFile_New;
		private System.Windows.Forms.MenuItem mnuFile_Open;
		private System.Windows.Forms.MenuItem mnuFile_Exit;
		protected internal System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolBarButton btn_new;
		private System.Windows.Forms.ToolBarButton btn_open;
		private System.Windows.Forms.ToolBarButton btn_save;
		private System.Windows.Forms.ToolBarButton sep1;
		private System.Windows.Forms.ToolBarButton btn_preview;
		private System.Windows.Forms.ToolBarButton btn_print;
		private System.Windows.Forms.ToolBarButton sep2;
		private System.Windows.Forms.ToolBarButton btn_cut;
		private System.Windows.Forms.ToolBarButton btn_copy;
		private System.Windows.Forms.ToolBarButton btn_paste;
		private System.Windows.Forms.ToolBarButton sep3;
		private System.Windows.Forms.ToolBarButton btn_undo;
		private System.Windows.Forms.ToolBarButton btn_redo;
		private System.Windows.Forms.ToolBarButton btn_find;
		private System.Windows.Forms.ToolBarButton sep4;
		private System.Windows.Forms.ToolBarButton btn_hf_properties;
		private System.Windows.Forms.ToolBarButton btn_hf_switch;
		private System.Windows.Forms.ToolBarButton btn_hf_firstpage;
		private System.Windows.Forms.ToolBarButton btn_hf_default;
		private TXTextControl.ButtonBar TxButtonBar1;
		private TXTextControl.StatusBar TxStatusBar1;
		private System.ComponentModel.IContainer components;

		public frmMDIParent(string[] args)
		{
			InitializeComponent();

			theToolBarHandler.MainForm = this;
			theToolBarHandler.MainFormToolbar = toolBar1;
		
			if (args.Length == 0)
				FileNew();
			else
			{
				foreach (string s in args)
				{
					FileOpen(s);
				}
			}
		}

		protected override void Dispose( bool disposing )
		{
			if (disposing)
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose (disposing);
		}


		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMDIParent));
			this.MainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuFile_New = new System.Windows.Forms.MenuItem();
			this.mnuFile_Open = new System.Windows.Forms.MenuItem();
			this.mnuFile_Exit = new System.Windows.Forms.MenuItem();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.btn_new = new System.Windows.Forms.ToolBarButton();
			this.btn_open = new System.Windows.Forms.ToolBarButton();
			this.btn_save = new System.Windows.Forms.ToolBarButton();
			this.sep1 = new System.Windows.Forms.ToolBarButton();
			this.btn_preview = new System.Windows.Forms.ToolBarButton();
			this.btn_print = new System.Windows.Forms.ToolBarButton();
			this.sep2 = new System.Windows.Forms.ToolBarButton();
			this.btn_cut = new System.Windows.Forms.ToolBarButton();
			this.btn_copy = new System.Windows.Forms.ToolBarButton();
			this.btn_paste = new System.Windows.Forms.ToolBarButton();
			this.sep3 = new System.Windows.Forms.ToolBarButton();
			this.btn_undo = new System.Windows.Forms.ToolBarButton();
			this.btn_redo = new System.Windows.Forms.ToolBarButton();
			this.btn_find = new System.Windows.Forms.ToolBarButton();
			this.sep4 = new System.Windows.Forms.ToolBarButton();
			this.btn_hf_properties = new System.Windows.Forms.ToolBarButton();
			this.btn_hf_switch = new System.Windows.Forms.ToolBarButton();
			this.btn_hf_firstpage = new System.Windows.Forms.ToolBarButton();
			this.btn_hf_default = new System.Windows.Forms.ToolBarButton();
			this.TxButtonBar1 = new TXTextControl.ButtonBar();
			this.TxStatusBar1 = new TXTextControl.StatusBar();
			this.SuspendLayout();
			// 
			// MainMenu1
			// 
			this.MainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuFile});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuFile_New,
																					this.mnuFile_Open,
																					this.mnuFile_Exit});
			this.mnuFile.MergeType = System.Windows.Forms.MenuMerge.MergeItems;
			this.mnuFile.Text = "&File";
			// 
			// mnuFile_New
			// 
			this.mnuFile_New.Index = 0;
			this.mnuFile_New.Text = "&New";
			this.mnuFile_New.Click += new System.EventHandler(this.mnuFile_New_Click);
			// 
			// mnuFile_Open
			// 
			this.mnuFile_Open.Index = 1;
			this.mnuFile_Open.Text = "&Open...";
			this.mnuFile_Open.Click += new System.EventHandler(this.mnuFile_Open_Click);
			// 
			// mnuFile_Exit
			// 
			this.mnuFile_Exit.Index = 2;
			this.mnuFile_Exit.MergeOrder = 10;
			this.mnuFile_Exit.Text = "E&xit";
			this.mnuFile_Exit.Click += new System.EventHandler(this.mnuFile_Exit_Click);
			// 
			// imageList1
			// 
			this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.White;
			// 
			// toolBar1
			// 
			this.toolBar1.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.btn_new,
																						this.btn_open,
																						this.btn_save,
																						this.sep1,
																						this.btn_preview,
																						this.btn_print,
																						this.sep2,
																						this.btn_cut,
																						this.btn_copy,
																						this.btn_paste,
																						this.sep3,
																						this.btn_undo,
																						this.btn_redo,
																						this.btn_find,
																						this.sep4,
																						this.btn_hf_properties,
																						this.btn_hf_switch,
																						this.btn_hf_firstpage,
																						this.btn_hf_default});
			this.toolBar1.ButtonSize = new System.Drawing.Size(23, 22);
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(848, 28);
			this.toolBar1.TabIndex = 5;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// btn_new
			// 
			this.btn_new.ImageIndex = 0;
			// 
			// btn_open
			// 
			this.btn_open.ImageIndex = 1;
			// 
			// btn_save
			// 
			this.btn_save.ImageIndex = 2;
			// 
			// sep1
			// 
			this.sep1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// btn_preview
			// 
			this.btn_preview.ImageIndex = 3;
			// 
			// btn_print
			// 
			this.btn_print.ImageIndex = 4;
			// 
			// sep2
			// 
			this.sep2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// btn_cut
			// 
			this.btn_cut.ImageIndex = 5;
			// 
			// btn_copy
			// 
			this.btn_copy.ImageIndex = 6;
			// 
			// btn_paste
			// 
			this.btn_paste.ImageIndex = 7;
			// 
			// sep3
			// 
			this.sep3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// btn_undo
			// 
			this.btn_undo.ImageIndex = 8;
			// 
			// btn_redo
			// 
			this.btn_redo.ImageIndex = 9;
			// 
			// btn_find
			// 
			this.btn_find.ImageIndex = 10;
			// 
			// sep4
			// 
			this.sep4.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// btn_hf_properties
			// 
			this.btn_hf_properties.ImageIndex = 11;
			// 
			// btn_hf_switch
			// 
			this.btn_hf_switch.ImageIndex = 12;
			// 
			// btn_hf_firstpage
			// 
			this.btn_hf_firstpage.ImageIndex = 13;
			// 
			// btn_hf_default
			// 
			this.btn_hf_default.ImageIndex = 14;
			// 
			// TxButtonBar1
			// 
			this.TxButtonBar1.Dock = System.Windows.Forms.DockStyle.Top;
			this.TxButtonBar1.Location = new System.Drawing.Point(0, 28);
			this.TxButtonBar1.Name = "TxButtonBar1";
			this.TxButtonBar1.Size = new System.Drawing.Size(848, 28);
			this.TxButtonBar1.TabIndex = 7;
			this.TxButtonBar1.TabStop = false;
			this.TxButtonBar1.Text = "TxButtonBar1";
			// 
			// TxStatusBar1
			// 
			this.TxStatusBar1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.TxStatusBar1.Location = new System.Drawing.Point(0, 628);
			this.TxStatusBar1.Name = "TxStatusBar1";
			this.TxStatusBar1.Size = new System.Drawing.Size(848, 19);
			this.TxStatusBar1.TabIndex = 6;
			this.TxStatusBar1.TabStop = false;
			// 
			// frmMDIParent
			// 
			this.AllowDrop = true;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(848, 647);
			this.Controls.Add(this.TxStatusBar1);
			this.Controls.Add(this.TxButtonBar1);
			this.Controls.Add(this.toolBar1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.IsMdiContainer = true;
			this.Menu = this.MainMenu1;
			this.Name = "frmMDIParent";
			this.Text = "TX Text Control Words";
			this.MdiChildActivate += new System.EventHandler(this.frmMDIParent_MdiChildActivate);
			this.DragDrop += new System.Windows.Forms.DragEventHandler(this.frmMDIParent_DragDrop);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.frmMDIParent_Paint);
			this.DragEnter += new System.Windows.Forms.DragEventHandler(this.frmMDIParent_DragEnter);
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main(string[] args) 
		{
			Application.Run(new frmMDIParent(args));
		}


#region " Menu Items "

		private void mnuFile_New_Click(object sender, System.EventArgs e)
		{
			FileNew();
		}

		private void mnuFile_Open_Click(object sender, System.EventArgs e)
		{
			FileOpen();
		}

		private void mnuFile_Exit_Click(object sender, System.EventArgs e)
		{
			Close();
		}
#endregion

#region " File New / File Open "

		public void FileNew()
		{
			frmMDIChild NewChild = (frmMDIChild)CreateDocumentWindow();
			NewChild.Show();
			theToolBarHandler.EnableToolbarButtons();
		}

		public void FileOpen()
		{
			try
			{
				frmMDIChild NewChild = (frmMDIChild)CreateDocumentWindow();
				NewChild.LoadFileOnCreate = true;
				NewChild.Show();
				if(NewChild.DocumentFileName == "")
					NewChild.Close();
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "TX Text Control Words");
			}
		}

		public void FileOpen(string FileName)
		{
			try
			{
				frmMDIChild NewChild = (frmMDIChild)CreateDocumentWindow();
				NewChild.LoadFileOnCreate = true;
				NewChild.DocumentFileName = FileName;
				NewChild.Show();
				theToolBarHandler.EnableToolbarButtons();
				if(NewChild.DocumentFileName == "")
					NewChild.Close();
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "TX Text Control Words");
			}
		}

		private Form CreateDocumentWindow()
		{
			frmMDIChild MDIChild = new frmMDIChild();

			MDIChild.MdiParent = this;
			MDIChild.Toolbar = toolBar1;
			MDIChild.ButtonBar = TxButtonBar1;
			MDIChild.StatusBar = TxStatusBar1;
			MDIChild.MainToolbarHandler = theToolBarHandler;

			return MDIChild;
		}
#endregion

#region " Toolbar "
		ToolbarHandler theToolBarHandler = new ToolbarHandler();

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			theToolBarHandler.ToolbarClickEventHandler(e.Button.ImageIndex);
		}

		private void frmMDIParent_MdiChildActivate(object sender, System.EventArgs e)
		{
			theToolBarHandler.EnableToolbarButtons();
		}

		private void frmMDIParent_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			e.Graphics.SetClip(this.ClientRectangle, System.Drawing.Drawing2D.CombineMode.Replace);
		}

#endregion

#region " Drag&Drop "

		// File Drag&Drop for the parent window.

		private void frmMDIParent_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			if (e.Data.GetDataPresent(DataFormats.FileDrop))
			{
				string[] args = (string[]) e.Data.GetData(DataFormats.FileDrop);

				string FileName = args[0].ToLower();
				if (FileName.EndsWith(".rtf") || FileName.EndsWith(".doc") ||
					FileName.EndsWith("txt") || FileName.EndsWith(".htm") ||
					FileName.EndsWith(".html") || FileName.EndsWith(".xml")) 
				{
					e.Effect = DragDropEffects.All;
				}
			}
		}

		private void frmMDIParent_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			string[] args = (string[]) e.Data.GetData(DataFormats.FileDrop);
			FileOpen(args[0]);		
		}

		#endregion
	}
}
